function RangeHelpOption_OnLoad()
	MeleeSpell_Description:SetText("Melee Spell");
	RangeSpell_Description:SetText("Range Spell");
	MeleeBar_Description:SetText("Melee Bar No.");
	RangeBar_Description:SetText("Range Bar No.");
	LockCombatBarText:SetText("Lock ActionBar During Combat");
	HideRangeInfoText:SetText("Hide Range Info Frame");
	EnableRangeHelpText:SetText("Enable Range Help");
	DisableBarSwitchText:SetText("Enable Acitonbar Switch");
	SetupVersionText:SetText("RangeHelp v"..RangeHelp_curVer);
end

function RangeHelpOption_OnShow()
	MeleeSpell:SetText(RangeConfig[RangeHelp_playerID]["melee name"]);
	RangeSpell:SetText(RangeConfig[RangeHelp_playerID]["range name"]);
	MeleeBar:SetText(RangeConfig[RangeHelp_playerID]["melee page"]);
	RangeBar:SetText(RangeConfig[RangeHelp_playerID]["range page"]);
	LockCombatBar:SetChecked(RangeConfig[RangeHelp_playerID]["lock"]);	
	HideRangeInfo:SetChecked(RangeConfig[RangeHelp_playerID]["hide rangeinfo"]);	
	DisableBarSwitch:SetChecked(RangeConfig[RangeHelp_playerID]["enable barswitch"]);
	EnableRangeHelp:SetChecked(RangeConfig[RangeHelp_playerID]["enable rangehelp"]);	
end

function RangeHelpOption_ApplyBut()
	mp = abs(MeleeBar:GetText());
	rp = abs(RangeBar:GetText());
	success = 0;
	if(EnableRangeHelp:GetChecked() == 1) then
		RangeConfig[RangeHelp_playerID]["enable rangehelp"] = 1;
	else
		RangeConfig[RangeHelp_playerID]["enable rangehelp"] = 0;
		HideUIPanel(TargetRangeInfo);
		return 1;
	end
	if(MeleeSpell:GetText() == "" or RangeSpell:GetText() == ""  or 
		MeleeBar:GetText() == "" or RangeBar:GetText() == "") then
		_ERRORMESSAGE("Please fill in all fields to proceed.");
	elseif(mp < 1 or mp > 6 or rp < 1 or rp > 6) then
		_ERRORMESSAGE("Invalid page number. Please enter a value between 1-6.");
	else
		RangeConfig[RangeHelp_playerID]["melee name"] = MeleeSpell:GetText();
		RangeConfig[RangeHelp_playerID]["range name"] = RangeSpell:GetText();
		RangeConfig[RangeHelp_playerID]["melee page"] = mp;
		RangeConfig[RangeHelp_playerID]["range page"] = rp;
		if(LockCombatBar:GetChecked() == 1) then
			RangeConfig[RangeHelp_playerID]["lock"] = 1;
		else
			RangeConfig[RangeHelp_playerID]["lock"] = 0;
		end
		if(HideRangeInfo:GetChecked() == 1) then
			RangeConfig[RangeHelp_playerID]["hide rangeinfo"] = 1;
		else
			RangeConfig[RangeHelp_playerID]["hide rangeinfo"] = 0;
		end
		if(DisableBarSwitch:GetChecked() == 1) then
			RangeConfig[RangeHelp_playerID]["enable barswitch"] = 1;
		else
			RangeConfig[RangeHelp_playerID]["enable barswitch"] = 0;
		end
		success = RangeHelpUpdateSlot(1);
		RangeHelpOption_OnShow();
	end
	return success;	
end

function RangeHelpOption_FillDef()
	MeleeSpell:SetText("Wing Clip");
	RangeSpell:SetText("Auto Shot");
end

function RangeHelpOption_ConfirmBut()
	hide = RangeHelpOption_ApplyBut();
	if(hide == 1) then
		HideUIPanel(RangeHelpSetup);
	end
end

function RangeHelpOption_CancelBut()
	HideUIPanel(RangeHelpSetup);
end

function RangeHelpOption_CustBut()
	HideUIPanel(RangeHelpSetup);
	ShowUIPanel(RangeHelpUISetup);
end

-------- UI Customisation Functions
local oldRangeInfoPos = { x=0.0, y=0.0 };

local TempColor = { ["melee ui"] = { BGColor = {r=0.0, g=0.0, b=0.0, alpha=0.7},
								BorColor = {r=0.0, g=0.0, b=0.0, alpha=0.7},
								FontColor = {r=0.0, g=0.0, b=0.0},
								Text = "" },
					["range ui"] = { BGColor = {r=0.0, g=0.0, b=0.0, alpha=0.7},
								BorColor = {r=0.0, g=0.0, b=0.0, alpha=0.7},
								FontColor = {r=0.0, g=0.0, b=0.0},
								Text = "" },
					["dead ui"] = { BGColor = {r=0.0, g=0.0, b=0.0, alpha=0.7},
								BorColor = {r=0.0, g=0.0, b=0.0, alpha=0.7},
								FontColor = {r=0.0, g=0.0, b=0.0},
								Text = "" },
					["oorange ui"] = { BGColor = {r=0.0, g=0.0, b=0.0, alpha=0.7},
								BorColor = {r=0.0, g=0.0, b=0.0, a=0.0, alpha=0.7},
								FontColor = {r=0.0, g=0.0, b=0.0},
								Text = "" },
					["all"] = { BGColor = {r=0.0, g=0.0, b=0.0, alpha=0.7},
								BorColor = {r=0.0, g=0.0, b=0.0, alpha=0.7},
								FontColor = {r=0.0, g=0.0, b=0.0},
								Text = "ALL" } }
local colIndex = "";
local colorModState = "";

RangeHelp_UISetup = 0;

function RangeHelpUIOption_OnLoad()
	ResizeCheckText:SetText("Resizable");
	MoveCheckText:SetText("Movable");
	FontHeightText:SetText("Font Size");
	FontHeightLow:SetText("0.0");
	FontHeightHigh:SetText("3.0");
	FontHeight:SetMinMaxValues(0, 3);
	FontHeight:SetValueStep(0.1);
	BGLockText:SetText("Background Colour Lock");
	BorderLockText:SetText("Border Colour Lock");
	FontLockText:SetText("Font Colour Lock");
	BGBorLinkText:SetText("Link Background and Border Colour");
	StateText_Description:SetText("Text");
	StateText_Description:SetPoint("TOPLEFT", "StateText", "TOPLEFT", -40, -8);
	UIVersionText:SetText("RangeHelp v"..RangeHelp_curVer);
	this:RegisterEvent("VARIABLES_LOADED");
	RangeHelp_UISetup = 0;
end

function RangeHelpUIOption_OnEvent()
	if(event == "VARIABLES_LOADED") then
		if (not RangeHelpOption) then
			RangeHelpOption = {};
			RangeHelpOption["Version"] = RangeHelp_curVer;
		else
			if(not RangeHelpOption["Version"]) then
				RangeHelpOption["Version"] = "2.1";
				RangeHelpOption["font height"] = 1.0;
			end
			if(RangeHelpOption["Version"] == "2.1") then		
				newRangeUI = {};
				newRangeUI[RangeHelp_playerID] = {};
				CopyTable(RangeHelpOption, newRangeUI[RangeHelp_playerID]);
				RangeHelpOption = newRangeUI;
				RangeHelpOption["Version"] = RangeHelp_curVer;
			end
		end
		RangeHelpOption["Version"] = RangeHelp_curVer;
		if(not RangeHelpOption[RangeHelp_playerID]) then
			RangeHelpOption[RangeHelp_playerID] = {};
			RangeHelpOption[RangeHelp_playerID]["resize"] = 0;
			RangeHelpOption[RangeHelp_playerID]["move"] = 1;
			RangeHelpOption[RangeHelp_playerID]["lock back"] = 0;
			RangeHelpOption[RangeHelp_playerID]["lock border"] = 0;
			RangeHelpOption[RangeHelp_playerID]["lock font"] = 0;
			RangeHelpOption[RangeHelp_playerID]["link backbg"] = 0;
			RangeHelpOption[RangeHelp_playerID]["melee ui"] = { BGColor={r=0.0,g=1.0,b=0.0,alpha=0.7},
										 BorColor={r=0.0,g=1.0,b=0.0,alpha=0.7},
										 FontColor={r=1.0,g=1.0,b=1.0},
										 Text="Melee" };
			RangeHelpOption[RangeHelp_playerID]["range ui"] = { BGColor={r=0.0,g=0.0,b=1.0,alpha=0.7},
										 BorColor={r=0.0,g=0.0,b=1.0,alpha=0.7},
										 FontColor={r=1.0,g=1.0,b=1.0},
										 Text="Range" };
			RangeHelpOption[RangeHelp_playerID]["dead ui"] = { BGColor={r=1.0,g=0.5,b=0.0,alpha=0.7},
										 BorColor={r=1.0,g=0.5,b=0.0,alpha=0.7},
										 FontColor={r=1.0,g=1.0,b=1.0},
										 Text="Dead Zone" };										 
			RangeHelpOption[RangeHelp_playerID]["oorange ui"] = { BGColor={r=1.0,g=0.0,b=0.0,alpha=0.7},
										 BorColor={r=1.0,g=0.0,b=0.0,alpha=0.7},
										 FontColor={r=1.0,g=1.0,b=1.0},
										 Text="Out of Range" };
			RangeHelpOption[RangeHelp_playerID]["font height"] = 1.0;	
		end
		
		RangeHelpSetUI();
	end
end

function RangeHelpSetUI()
	if(RangeHelpOption[RangeHelp_playerID]["move"] == 0 and RangeHelpOption[RangeHelp_playerID]["resize"] == 0) then
		TargetRangeInfo:EnableMouse("false");
	else
		TargetRangeInfo:EnableMouse("true");
	end
end

function RangeDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, RangeDropDown_Initialize);
end

function RangeHelpUIOption_OnShow()
	BGColorSel:Disable();
	BorColorSel:Disable();
	FontColorSel:Disable();
	UIDropDownMenu_ClearAll(RangeDropDown);	
	ResizeCheck:SetChecked(RangeHelpOption[RangeHelp_playerID]["resize"]);
	MoveCheck:SetChecked(RangeHelpOption[RangeHelp_playerID]["move"]);
	BGLock:SetChecked(RangeHelpOption[RangeHelp_playerID]["lock back"]);
	BorderLock:SetChecked(RangeHelpOption[RangeHelp_playerID]["lock border"]);
	FontLock:SetChecked(RangeHelpOption[RangeHelp_playerID]["lock font"]);
	BGBorLink:SetChecked(RangeHelpOption[RangeHelp_playerID]["link backbg"]);
	if(BGBorLink:GetChecked() == 1) then
		BorderLock:SetChecked(0);
		BorderLock:Disable();
	end
	FontHeight:SetValue(RangeHelpOption[RangeHelp_playerID]["font height"]);
	colIndex = "";
	
	RangeHelp_UISetup = 1;	
	TargetRangeInfo:Show();
	TargetRange:SetText("UI Customise");
	TargetRange:SetTextColor(1,1,1);
	TargetRangeInfo:SetBackdropColor(1, 1, 1, 1);
	TargetRangeInfo:SetBackdropBorderColor(1, 1, 1, 1);
	StateText:SetText("");
	CopyTable(RangeHelpOption[RangeHelp_playerID]["melee ui"], TempColor["melee ui"]);
	CopyTable(RangeHelpOption[RangeHelp_playerID]["dead ui"], TempColor["dead ui"]);
	CopyTable(RangeHelpOption[RangeHelp_playerID]["range ui"], TempColor["range ui"]);
	CopyTable(RangeHelpOption[RangeHelp_playerID]["oorange ui"], TempColor["oorange ui"]);
	CopyTable(RangeHelpOption[RangeHelp_playerID]["melee ui"], TempColor["all"]);
end

function CopyTable(srcTable, destTable)
	local si, sv = next(srcTable, nil);
	while si do
		if(type(sv) ~= "table") then
			destTable[si] = srcTable[si];
		else
			destTable[si] = {};
			dv = destTable[si];
			CopyTable(sv, dv);
		end
		si, sv = next(srcTable, si);
	end
end

function RangeDropDown_Initialize()
	info = {};
	info.text = "Melee";
	info.value = 0;
	info.func = RangeDropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Dead Zone";
	info.value = 1;
	info.func = RangeDropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Range";
	info.value = 2;
	info.func = RangeDropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Out of Range";
	info.value = 3;
	info.func = RangeDropDown_OnClick;
	UIDropDownMenu_AddButton(info);	
	
	info = {};
	info.text = "All State";
	info.value = 4;
	info.func = RangeDropDown_OnClick;
	UIDropDownMenu_AddButton(info);	
end

function RangeDropDown_OnClick()
	UIDropDownMenu_SetSelectedValue(RangeDropDown, this.value);
	RangeHelpUIOption_ColorSetup(this.value);
	--oldRangeInfoPos.y = TargetRangeInfo:GetBottom();
	--oldRangeInfoPos.x = TargetRangeInfo:GetLeft();
	TargetRangeInfo:Show();
	TargetRange:SetText(TempColor[colIndex].Text);	
	if(this.value ~= 4) then
		StateText:SetText(TempColor[colIndex].Text);
	else
		StateText:SetText("");
	end
	--TargetRangeInfo:SetPoint("BOTTOM", "RangeHelpUISetup", "TOP", 0, 20);
end

function RangeHelpUIOption_ColorSetup(value)
	if(value == nil) then
		value = UIDropDownMenu_GetSelectedValue(RangeDropDown);
	end
	if(value ~= nil) then
		HideUIPanel(RangeHelpColorPicker);
		BGColorSel:Disable();
		BorColorSel:Disable();
		FontColorSel:Disable();
		if(value ~= 4) then
			if(value == 0) then
				colIndex = "melee ui";
			elseif(value == 2) then
				colIndex = "range ui";
			elseif(value == 1) then
				colIndex = "dead ui";
			elseif(value == 3) then
				colIndex = "oorange ui";
			end

			if(BGLock:GetChecked() == nil) then
				BGColorSel:Enable();
				TargetRangeInfo:SetBackdropColor(TempColor[colIndex].BGColor.r,
									TempColor[colIndex].BGColor.g,
									TempColor[colIndex].BGColor.b,
									TempColor[colIndex].BGColor.alpha);
			else
				TargetRangeInfo:SetBackdropColor(TempColor["all"].BGColor.r,
										TempColor["all"].BGColor.g,
										TempColor["all"].BGColor.b,
										TempColor["all"].BGColor.alpha);
			end 
			if(BorderLock:GetChecked() == nil and BGBorLink:GetChecked() == nil) then
				BorColorSel:Enable();
				TargetRangeInfo:SetBackdropBorderColor(TempColor[colIndex].BorColor.r,
														TempColor[colIndex].BorColor.g,
														TempColor[colIndex].BorColor.b,
														TempColor[colIndex].BorColor.alpha);
			elseif(BGLock:GetChecked() == 1 and BGBorLink:GetChecked() == 1) then
				TargetRangeInfo:SetBackdropBorderColor(TempColor["all"].BGColor.r,
														TempColor["all"].BGColor.g,
														TempColor["all"].BGColor.b,
														TempColor["all"].BGColor.alpha);
			elseif(BorderLock:GetChecked() == 1) then
				TargetRangeInfo:SetBackdropBorderColor(TempColor["all"].BorColor.r,
														TempColor["all"].BorColor.g,
														TempColor["all"].BorColor.b,
														TempColor["all"].BorColor.alpha);
			elseif(BGBorLink:GetChecked() == 1) then
				TargetRangeInfo:SetBackdropBorderColor(TempColor[colIndex].BGColor.r,
														TempColor[colIndex].BGColor.g,
														TempColor[colIndex].BGColor.b,
														TempColor[colIndex].BGColor.alpha);
			end
			if(FontLock:GetChecked() == nil) then
				FontColorSel:Enable();
				TargetRange:SetTextColor(TempColor[colIndex].FontColor.r,
											TempColor[colIndex].FontColor.g,
											TempColor[colIndex].FontColor.b);
			else
				TargetRange:SetTextColor(TempColor["all"].FontColor.r,
											TempColor["all"].FontColor.g,
											TempColor["all"].FontColor.b);
			end
		elseif(value == 4) then
			colIndex = "all";
			if(BGLock:GetChecked() == 1) then
				BGColorSel:Enable();
				TargetRangeInfo:SetBackdropColor(TempColor[colIndex].BGColor.r,
									TempColor[colIndex].BGColor.g,
									TempColor[colIndex].BGColor.b,
									TempColor[colIndex].BGColor.alpha);
			else
				TargetRangeInfo:SetBackdropColor(0,0,0,0);
			end 
			if(BorderLock:GetChecked() == 1 and BGBorLink:GetChecked() == nil) then
				BorColorSel:Enable();
				TargetRangeInfo:SetBackdropBorderColor(TempColor[colIndex].BorColor.r,
														TempColor[colIndex].BorColor.g,
														TempColor[colIndex].BorColor.b,
														TempColor[colIndex].BorColor.alpha);
			elseif(BGLock:GetChecked() == 1 and BGBorLink:GetChecked() == 1) then
				TargetRangeInfo:SetBackdropBorderColor(TempColor[colIndex].BGColor.r,
														TempColor[colIndex].BGColor.g,
														TempColor[colIndex].BGColor.b,
														TempColor[colIndex].BGColor.alpha);
			else
				TargetRangeInfo:SetBackdropBorderColor(0,0,0,0);
			end
			if(FontLock:GetChecked() == 1) then
				FontColorSel:Enable();
				TargetRange:SetTextColor(TempColor[colIndex].FontColor.r,
											TempColor[colIndex].FontColor.g,
											TempColor[colIndex].FontColor.b);
				TempColor[colIndex].Text = "Text Colour";
				TargetRange:SetText(TempColor[colIndex].Text);
			else
				TempColor[colIndex].Text = "";
				TargetRange:SetText(TempColor[colIndex].Text);				
			end
		end
	end
end

function RangeHelpUIOption_MoveCheck()
	if(MoveCheck:GetChecked() == 1) then
		RangeHelpOption[RangeHelp_playerID]["move"] = 1;
	else
		RangeHelpOption[RangeHelp_playerID]["move"] = 0;
	end
	RangeHelpSetUI();
end

function RangeHelpUIOption_ResizeCheck()
	if(ResizeCheck:GetChecked() == 1) then
		RangeHelpOption[RangeHelp_playerID]["resize"] = 1;
	else
		RangeHelpOption[RangeHelp_playerID]["resize"] = 0;
	end
	RangeHelpSetUI();
end

function RangeHelpUIOption_FontHeightChanged()
	RangeInfoFontFrame:SetScale(FontHeight:GetValue());
end

function RangeHelpUIOption_BGColourSel()
	colorModState = "BGColor";
	RangeHelpColorPicker:SetColorRGB(TempColor[colIndex].BGColor.r, 
										TempColor[colIndex].BGColor.g,
										TempColor[colIndex].BGColor.b);
	RangeHelpOpacitySlider:SetValue(TempColor[colIndex].BGColor.alpha);
	RangeHelpUIOption_ColorSetup(value);
	ShowUIPanel(RangeHelpColorPicker);
end

function RangeHelpUIOption_BorColourSel()
	colorModState = "BorColor";
	RangeHelpColorPicker:SetColorRGB(TempColor[colIndex].BorColor.r, 
										TempColor[colIndex].BorColor.g,
										TempColor[colIndex].BorColor.b);
	RangeHelpOpacitySlider:SetValue(TempColor[colIndex].BorColor.alpha);
	RangeHelpUIOption_ColorSetup(value);
	ShowUIPanel(RangeHelpColorPicker);
end

function RangeHelpUIOption_FontColourSel()
	colorModState = "FontColor";
	RangeHelpColorPicker:SetColorRGB(TempColor[colIndex].FontColor.r, 
										TempColor[colIndex].FontColor.g,
										TempColor[colIndex].FontColor.b);
	RangeHelpOpacitySlider:SetValue(0.0);
	RangeHelpUIOption_ColorSetup(value);
	ShowUIPanel(RangeHelpColorPicker);
end

function RangeHelpUIOption_StateTextChanged()
	value = UIDropDownMenu_GetSelectedValue(RangeDropDown);
	if(value ~= 4 and value ~= nil) then
		TargetRange:SetText(StateText:GetText());
		TempColor[colIndex].Text = StateText:GetText();
	end
end

function RangeHelpUIOption_ApplyBut()
	RangeHelpOption[RangeHelp_playerID]["font height"] = FontHeight:GetValue();

	if(BGLock:GetChecked() == 1) then
		RangeHelpOption[RangeHelp_playerID]["lock back"] = 1;
	else
		RangeHelpOption[RangeHelp_playerID]["lock back"] = 0;	
	end 
	
	if(BorderLock:GetChecked() == 1) then
		RangeHelpOption[RangeHelp_playerID]["lock border"] = 1;	
	else
		RangeHelpOption[RangeHelp_playerID]["lock border"] = 0;
	end
	
	if(FontLock:GetChecked() == 1) then
		RangeHelpOption[RangeHelp_playerID]["lock font"] = 1;
	else
		RangeHelpOption[RangeHelp_playerID]["lock font"] = 0;	
	end
	
	if(BGBorLink:GetChecked() == 1) then
		RangeHelpOption[RangeHelp_playerID]["link backbg"] = 1;
	else
		RangeHelpOption[RangeHelp_playerID]["link backbg"] = 0;
	end
	
	CopyTable(TempColor["melee ui"], RangeHelpOption[RangeHelp_playerID]["melee ui"]);
	CopyTable(TempColor["dead ui"], RangeHelpOption[RangeHelp_playerID]["dead ui"]);
	CopyTable(TempColor["range ui"], RangeHelpOption[RangeHelp_playerID]["range ui"]);
	CopyTable(TempColor["oorange ui"], RangeHelpOption[RangeHelp_playerID]["oorange ui"]);
	
	if(RangeHelpOption[RangeHelp_playerID]["lock back"] == 0 and RangeHelpOption[RangeHelp_playerID]["link backbg"] == 1) then
		CopyTable(TempColor["melee ui"].BGColor, RangeHelpOption[RangeHelp_playerID]["melee ui"].BorColor);
		CopyTable(TempColor["dead ui"].BGColor, RangeHelpOption[RangeHelp_playerID]["dead ui"].BorColor);
		CopyTable(TempColor["range ui"].BGColor, RangeHelpOption[RangeHelp_playerID]["range ui"].BorColor);
		CopyTable(TempColor["oorange ui"].BGColor, RangeHelpOption[RangeHelp_playerID]["oorange ui"].BorColor);
	end
	if(RangeHelpOption[RangeHelp_playerID]["lock back"] == 1) then
		CopyTable(TempColor["all"].BGColor, RangeHelpOption[RangeHelp_playerID]["melee ui"].BGColor);
		CopyTable(TempColor["all"].BGColor, RangeHelpOption[RangeHelp_playerID]["dead ui"].BGColor);
		CopyTable(TempColor["all"].BGColor, RangeHelpOption[RangeHelp_playerID]["range ui"].BGColor);
		CopyTable(TempColor["all"].BGColor, RangeHelpOption[RangeHelp_playerID]["oorange ui"].BGColor);
	end
	if(RangeHelpOption[RangeHelp_playerID]["lock back"] == 1 and RangeHelpOption[RangeHelp_playerID]["link backbg"] == 1) then
		CopyTable(TempColor["all"].BGColor, RangeHelpOption[RangeHelp_playerID]["melee ui"].BorColor);
		CopyTable(TempColor["all"].BGColor, RangeHelpOption[RangeHelp_playerID]["dead ui"].BorColor);
		CopyTable(TempColor["all"].BGColor, RangeHelpOption[RangeHelp_playerID]["range ui"].BorColor);
		CopyTable(TempColor["all"].BGColor, RangeHelpOption[RangeHelp_playerID]["oorange ui"].BorColor);
	end
	if(RangeHelpOption[RangeHelp_playerID]["lock border"] == 1) then
		CopyTable(TempColor["all"].BorColor, RangeHelpOption[RangeHelp_playerID]["melee ui"].BorColor);
		CopyTable(TempColor["all"].BorColor, RangeHelpOption[RangeHelp_playerID]["dead ui"].BorColor);
		CopyTable(TempColor["all"].BorColor, RangeHelpOption[RangeHelp_playerID]["range ui"].BorColor);
		CopyTable(TempColor["all"].BorColor, RangeHelpOption[RangeHelp_playerID]["oorange ui"].BorColor);	
	end
	if(RangeHelpOption[RangeHelp_playerID]["lock font"] == 1) then
		CopyTable(TempColor["all"].FontColor, RangeHelpOption[RangeHelp_playerID]["melee ui"].FontColor);
		CopyTable(TempColor["all"].FontColor, RangeHelpOption[RangeHelp_playerID]["dead ui"].FontColor);
		CopyTable(TempColor["all"].FontColor, RangeHelpOption[RangeHelp_playerID]["range ui"].FontColor);
		CopyTable(TempColor["all"].FontColor, RangeHelpOption[RangeHelp_playerID]["oorange ui"].FontColor);	
	end
	RangeHelpSetUI();
end

function RangeHelpUIOption_ConfirmBut()
	RangeHelpUIOption_ApplyBut();
	RangeHelpUIOption_CancelBut();
end

function RangeHelpUIOption_CancelBut()
	HideUIPanel(RangeHelpUISetup);
	HideUIPanel(RangeHelpColorPicker);
	RangeHelp_UISetup = 0;
	--TargetRangeInfo:SetPoint("BOTTOM", "UIParent", "TOP", 0, -oldRangeInfoPos.y);
	--DEFAULT_CHAT_FRAME:AddMessage("coord x:"..oldRangeInfoPos.x.." coord y:"..oldRangeInfoPos.y);
end

function RangeHelpUIOption_DefaultBut()
	BGLock:SetChecked(0);
	BorderLock:SetChecked(0);
	FontLock:SetChecked(1);
	BGBorLink:SetChecked(1);
	TempColor["melee ui"] = { BGColor={r=0.0,g=1.0,b=0.0,alpha=0.7},
								 BorColor={r=0.0,g=1.0,b=0.0,alpha=0.7},
								 FontColor={r=1.0,g=1.0,b=1.0},
								 Text="Melee" };
	TempColor["range ui"] = { BGColor={r=0.0,g=0.0,b=1.0,alpha=0.7},
								 BorColor={r=0.0,g=0.0,b=1.0,alpha=0.7},
								 FontColor={r=1.0,g=1.0,b=1.0},
								 Text="Range" };
	TempColor["dead ui"] = { BGColor={r=1.0,g=0.5,b=0.0,alpha=0.7},
								 BorColor={r=1.0,g=0.5,b=0.0,alpha=0.7},
								 FontColor={r=1.0,g=1.0,b=1.0},
								 Text="Dead Zone" };										 
	TempColor["oorange ui"] = { BGColor={r=1.0,g=0.0,b=0.0,alpha=0.7},
								 BorColor={r=1.0,g=0.0,b=0.0,alpha=0.7},
								 FontColor={r=1.0,g=1.0,b=1.0},
								 Text="Out of Range" };	
	FontHeight:SetValue(1.0);
	
	BGColorSel:Disable();
	BorColorSel:Disable();
	FontColorSel:Disable();
	UIDropDownMenu_ClearAll(RangeDropDown);	
	colIndex = "";
	RangeHelp_UISetup = 1;	
	TargetRangeInfo:Show();
	TargetRange:SetText("UI Customise");
	TargetRange:SetTextColor(1,1,1);
	TargetRangeInfo:SetBackdropColor(1, 1, 1, 1);
	TargetRangeInfo:SetBackdropBorderColor(1, 1, 1, 1);
	StateText:SetText("");
end

---- Color select functions
function RangeHelpUIOption_ColorOkay()
	TempColor[colIndex][colorModState].r, 
		TempColor[colIndex][colorModState].g, 
		TempColor[colIndex][colorModState].b = RangeHelpColorPicker:GetColorRGB();
	if(colorModState ~= "FontColor") then
		TempColor[colIndex][colorModState].alpha = RangeHelpOpacitySlider:GetValue(); 
	end
end

function RangeHelpUIOption_ColorCancel()
	RangeHelpUIOption_ColorSetup();
end

function RangeHelpUIOption_ColorOpacityChange()
	r, g, b = RangeHelpColorPicker:GetColorRGB();
	if(colorModState == "BGColor") then
		TargetRangeInfo:SetBackdropColor(r,g,b, RangeHelpOpacitySlider:GetValue());
		if(BGBorLink:GetChecked() == 1) then
			TargetRangeInfo:SetBackdropBorderColor(r,g,b, RangeHelpOpacitySlider:GetValue());		
		end
	elseif(colorModState == "BorColor") then
		TargetRangeInfo:SetBackdropBorderColor(r,g,b, RangeHelpOpacitySlider:GetValue());
	end
end

function RangeHelpUIOption_ColorSelect()
	r, g, b = RangeHelpColorPicker:GetColorRGB();
	if(colorModState == "BGColor") then
		TargetRangeInfo:SetBackdropColor(r,g,b, RangeHelpOpacitySlider:GetValue());
		if(BGBorLink:GetChecked() == 1) then
			TargetRangeInfo:SetBackdropBorderColor(r,g,b, RangeHelpOpacitySlider:GetValue());		
		end
	elseif(colorModState == "BorColor") then
		TargetRangeInfo:SetBackdropBorderColor(r,g,b, RangeHelpOpacitySlider:GetValue());
	elseif(colorModState == "FontColor") then
		TargetRange:SetTextColor(r,g,b);
	end
end
